#include <stdio.h>

#define TUDENGEID 5
#define EKSAMEID 6

int keskminehinne(int, int, int [][EKSAMEID]);
void v2ljastus(int, int [][EKSAMEID]);
void jaotus(int, int [][EKSAMEID], int [][EKSAMEID], int [][EKSAMEID]);
void j_v2ljastus(int [][EKSAMEID], int [][EKSAMEID]);
int main(void) {
	int tulemused[TUDENGEID][EKSAMEID]={{54, 71, 59, 90, 62, 56},
                                        {69, 83, 96, 90, 70, 79},
                                        {90, 91, 71, 89, 55, 97},
                                        {78, 82, 97, 87, 90, 97},
                                        {98, 91, 73, 86, 76, 98}};
    int h[TUDENGEID + 1][EKSAMEID], mh[TUDENGEID + 1][EKSAMEID];
    v2ljastus(keskminehinne(0, TUDENGEID, tulemused), tulemused);
    jaotus(keskminehinne(0, TUDENGEID, tulemused),h,mh,tulemused);
    j_v2ljastus(h, mh);
	return 0;
} ////////////////////////////////////////////////////////////////////////
int keskminehinne(int alg, int l6pp, int tul[][EKSAMEID]) {
	int i, j, avg = 0, vahe;
	
	for( i = alg, vahe = 0; i < l6pp; i++, vahe++ ) {
		for( j = 0 ; j < EKSAMEID; j++ ) {
			avg += tul[i][j];
		}
	}
	
	avg /= (vahe*EKSAMEID);
	
	return avg;
} ////////////////////////////////////////////////////////////////////////
void v2ljastus(int avg, int tul[][EKSAMEID]) {
	int i;
	printf("Keskmine: %d\n", avg);
	
	for( i = 0; i < TUDENGEID; i++ ) {
		printf("Tudengi %d keskmine: %d\n", i + 1, keskminehinne(i, i + 1, tul));
	}
} ////////////////////////////////////////////////////////////////////////
void jaotus(int avg, int hea[][EKSAMEID], int mittehea[][EKSAMEID], int hinded[][EKSAMEID]) {
	int i, j, k, l;
	
	for( i = 0, k = 0, l = 0; i < TUDENGEID; i++) {
		if(keskminehinne(i, i + 1, hinded) >= avg) {
			for(j = 0; j < EKSAMEID; j++) {
				hea[k][j] = hinded[i][j];
			}
			k++;
		} else {
			for(j = 0; j < EKSAMEID; j++) {
				mittehea[l][j] = hinded[i][j];
			}
			l++;
		}
	}
	hea[k][0] = -1;
	mittehea[l][0] = -1;
} ////////////////////////////////////////////////////////////////////////
void j_v2ljastus(int head_hinded[][EKSAMEID], int halvad_hinded[][EKSAMEID]){
	int i, j, k, l;
	
	//Leiame heade hinnete suuruse
	for( i = 0; head_hinded[i][0] != -1; i++);
	
	//Leiame pahade hinnete suuruse
	for( j = 0; halvad_hinded[j][0] != -1; j++);
	
	for( k = 0; k < i; k++ ) {
		printf("Head tulemused: ");
		for( l = 0; l < EKSAMEID; l++ ) {
			printf("%d ", head_hinded[k][l]);
		}
		printf("\n");
	}
	
	for( k = 0; k < j; k++ ) {
		printf("Halvad tulemused: ");
		for( l = 0; l < EKSAMEID; l++ ) {
			printf("%d ", halvad_hinded[k][l]);
		}
		printf("\n");
	}
	
} ////////////////////////////////////////////////////////////////////////
